#include <windows.h>
#include <stdio.h>
#include "display.h"

#define MAX_LOADSTRING 255

void DisplayLastError(char *szMessage)
{
	LPTSTR lpMsgBuf;
	DWORD dwLastError;
	HANDLE hInst;

#ifdef DEBUG_0
	return;
#endif
	dwLastError = GetLastError();
	if(dwLastError != 0)
	{
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			dwLastError,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR)&lpMsgBuf,
			MAX_LOADSTRING,
			NULL 
			);
	}
	else
	{
		lpMsgBuf = LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * 3);
		if(lpMsgBuf == NULL)
			return;
		lstrcpy(lpMsgBuf, TEXT("*\0"));
	}

	// Display the error message
	hInst = GetModuleHandle(NULL);
	printf("%s : (%u) %s\n", szMessage, dwLastError, lpMsgBuf);
	
	// Free the buffer
	LocalFree(lpMsgBuf);
}

void DisplayLastErrorWSA(char *szMessage)
{
	LPTSTR lpMsgBuf;
	DWORD dwLastError;
	HANDLE hInst;

#ifdef DEBUG_0
	return;
#endif
	dwLastError = WSAGetLastError();
	if(dwLastError != 0)
	{
		if(FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			dwLastError,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Language par dfaut
			(LPTSTR)&lpMsgBuf,
			MAX_LOADSTRING,
			NULL 
			) == 0)
		{
			lpMsgBuf = LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * 3);
			if(lpMsgBuf == NULL)
				return;
			lstrcpy(lpMsgBuf, TEXT("-\0"));
		}
	}
	else
	{
		lpMsgBuf = LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * 3);
		if(lpMsgBuf == NULL)
			return;
		lstrcpy(lpMsgBuf, TEXT("*\0"));
	}
	// Display the error message
	hInst = GetModuleHandle(NULL);
	printf("%s : (%u) %s\n", szMessage, dwLastError, lpMsgBuf);
	
	// Free the buffer
	LocalFree(lpMsgBuf);
}
